SocketHandler (Java SE 26 & JDK 26)
Description: declaration: module: java.logging, package: java.util.logging, class: SocketHandler
Keywords: java.util.logging.SocketHandler class

# Class SocketHandler

java.lang.Object
java.util.logging.Handler
java.util.logging.StreamHandler
java.util.logging.SocketHandler

public class SocketHandler extends StreamHandler
Simple network logging `Handler`.

`LogRecords` are published to a network stream connection. By default the `XMLFormatter` class is used for formatting.

Configuration: By default each `SocketHandler` is initialized using the following `LogManager` configuration properties where `<handler-name>` refers to the fully-qualified class name of the handler. If properties are not defined (or have invalid values) then the specified default values are used.

- <handler-name>.level specifies the default level for the `Handler` (defaults to `Level.ALL`).
- <handler-name>.filter specifies the name of a `Filter` class to use (defaults to no `Filter`).
- <handler-name>.formatter specifies the name of a `Formatter` class to use (defaults to `java.util.logging.XMLFormatter`).
- <handler-name>.encoding the name of the character set encoding to use (defaults to the default platform encoding).
- <handler-name>.host specifies the target host name to connect to (no default).
- <handler-name>.port specifies the target TCP port to use (no default).

For example, the properties for `SocketHandler` would be:

- java.util.logging.SocketHandler.level=INFO
- java.util.logging.SocketHandler.formatter=java.util.logging.SimpleFormatter

For a custom handler, e.g. com.foo.MyHandler, the properties would be:

- com.foo.MyHandler.level=INFO
- com.foo.MyHandler.formatter=java.util.logging.SimpleFormatter

The output IO stream is buffered, but is flushed after each `LogRecord` is written.

Since:
  1.4

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SocketHandler()`
  Create a `SocketHandler`, using only `LogManager` properties (or their defaults).
  `SocketHandler(String host, int port)`
  Construct a `SocketHandler` using a specified host and port.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Close this output stream.
  `void`
  `publish(LogRecord record)`
  Format and publish a `LogRecord`.

  ### Methods declared in class StreamHandler

  `flush, isLoggable, setEncoding, setOutputStream`
  Modifier and Type
  Method
  Description
  `void`
  `flush()`
  Flush any buffered messages.
  `boolean`
  `isLoggable(LogRecord record)`
  Check if this `Handler` would actually log a given `LogRecord`.
  `void`
  `setEncoding(String encoding)`
  Set (or change) the character encoding used by this `Handler`.
  `protected void`
  `setOutputStream(OutputStream out)`
  Change the output stream.

  ### Methods declared in class Handler

  `getEncoding, getErrorManager, getFilter, getFormatter, getLevel, reportError, setErrorManager, setFilter, setFormatter, setLevel`
  Modifier and Type
  Method
  Description
  `String`
  `getEncoding()`
  Return the character encoding for this `Handler`.
  `ErrorManager`
  `getErrorManager()`
  Retrieves the ErrorManager for this Handler.
  `Filter`
  `getFilter()`
  Get the current `Filter` for this `Handler`.
  `Formatter`
  `getFormatter()`
  Return the `Formatter` for this `Handler`.
  `Level`
  `getLevel()`
  Get the log level specifying which messages will be logged by this `Handler`.
  `protected void`
  `reportError(String msg, Exception ex, int code)`
  Protected convenience method to report an error to this Handler's ErrorManager.
  `void`
  `setErrorManager(ErrorManager em)`
  Define an ErrorManager for this Handler.
  `void`
  `setFilter(Filter newFilter)`
  Set a `Filter` to control output on this `Handler`.
  `void`
  `setFormatter(Formatter newFormatter)`
  Set a `Formatter`.
  `void`
  `setLevel(Level newLevel)`
  Set the log level specifying which message levels will be logged by this `Handler`.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SocketHandler

    public SocketHandler() throws IOException
    Create a `SocketHandler`, using only `LogManager` properties (or their defaults).
    Throws:
      `IllegalArgumentException` - if the host or port are invalid or are not specified as LogManager properties.
      `IOException` - if we are unable to connect to the target host and port.

  - ### SocketHandler

    public SocketHandler(String host, int port) throws IOException
    Construct a `SocketHandler` using a specified host and port. The `SocketHandler` is configured based on `LogManager` properties (or their default values) except that the given target host and port arguments are used. If the host argument is empty, but not null String then the localhost is used.
    Parameters:
      `host` - target host.
      `port` - target port.
    Throws:
      `IllegalArgumentException` - if the host or port are invalid.
      `IOException` - if we are unable to connect to the target host and port.

- ## Method Details

  - ### close

    public void close()
    Close this output stream.
    Overrides:
      `close` in class `StreamHandler`

  - ### publish

    public void publish(LogRecord record)
    Format and publish a `LogRecord`.
    Overrides:
      `publish` in class `StreamHandler`
    Implementation Requirements:
      This method is not synchronized, and subclasses must not define overridden `publish()` methods to be `synchronized` if they call `super.publish()` or format user arguments. See the discussion in java.util.logging.Handler for more information.
    Parameters:
      `record` - description of the log event. A null record is silently ignored and is not published